package controller

import (
	"github.com/gin-gonic/gin"
	"github.com/go_gateway_admin/dto"
	"github.com/go_gateway_admin/middleware"
)

type AdminLoginController struct {
}

func AdminLoginRegister(router *gin.RouterGroup) {
	curd := AdminLoginController{}
	router.POST("/login", curd.Login)
	//router.GET("/loginout", curd.LoginOut)
}

// AdminLgoin godoc
// @Summary 管理员登陆
// @Description 管理员登陆
// @Tags 管理员借口
// @ID	/admin/login
// @Accept  json
// @Produce  json
// @Param body body dto.AdminLoginInput true "body"
// @Success 200 {object} middleware.Response{data=dto.AdminLoginOutput} "success"
// @Router /admin/login [post]
func (admin *AdminLoginController) Login(c *gin.Context) {

	params := &dto.AdminLoginInput{}

	if err := params.BindingValidParams(c); err != nil {
		middleware.ResponseError(c, 1001, err)
		return
	}

	out := &dto.AdminLoginOutput{Token: params.UserName}

	middleware.ResponseSuccess(c, out)
}
